diff -ruNp linux-2.6.34.5/fs/namei.c linux-2.6.34.5-cher1/fs/namei.c
--- linux-2.6.34.5/fs/namei.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/namei.c	2010-08-26 14:45:12.283567544 +0400
@@ -2016,6 +2016,11 @@ SYSCALL_DEFINE4(mknodat, int, dfd, const
 	struct dentry *dentry;
 	struct nameidata nd;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (S_ISDIR(mode))
 		return -EPERM;
 
@@ -2096,6 +2101,11 @@ SYSCALL_DEFINE3(mkdirat, int, dfd, const
 	struct dentry *dentry;
 	struct nameidata nd;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_parent(dfd, pathname, &nd, &tmp);
 	if (error)
 		goto out_err;
@@ -2242,6 +2252,11 @@ exit1:
 
 SYSCALL_DEFINE1(rmdir, const char __user *, pathname)
 {
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	return do_rmdir(AT_FDCWD, pathname);
 }
 
@@ -2339,6 +2354,11 @@ slashes:
 
 SYSCALL_DEFINE3(unlinkat, int, dfd, const char __user *, pathname, int, flag)
 {
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if ((flag & ~AT_REMOVEDIR) != 0)
 		return -EINVAL;
 
@@ -2350,6 +2370,11 @@ SYSCALL_DEFINE3(unlinkat, int, dfd, cons
 
 SYSCALL_DEFINE1(unlink, const char __user *, pathname)
 {
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	return do_unlinkat(AT_FDCWD, pathname);
 }
 
@@ -2382,6 +2407,11 @@ SYSCALL_DEFINE3(symlinkat, const char __
 	struct dentry *dentry;
 	struct nameidata nd;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	from = getname(oldname);
 	if (IS_ERR(from))
 		return PTR_ERR(from);
@@ -2475,6 +2505,11 @@ SYSCALL_DEFINE5(linkat, int, olddfd, con
 	int error;
 	char *to;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if ((flags & ~AT_SYMLINK_FOLLOW) != 0)
 		return -EINVAL;
 
@@ -2678,6 +2713,11 @@ SYSCALL_DEFINE4(renameat, int, olddfd, c
 	char *to;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_parent(olddfd, oldname, &oldnd, &from);
 	if (error)
 		goto exit;
diff -ruNp linux-2.6.34.5/fs/namespace.c linux-2.6.34.5-cher1/fs/namespace.c
--- linux-2.6.34.5/fs/namespace.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/namespace.c	2010-08-26 14:45:12.290562178 +0400
@@ -1138,6 +1138,11 @@ SYSCALL_DEFINE2(umount, char __user *, n
 	int retval;
 	int lookup_flags = 0;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (flags & ~(MNT_FORCE | MNT_DETACH | MNT_EXPIRE | UMOUNT_NOFOLLOW))
 		return -EINVAL;
 
@@ -2136,6 +2141,11 @@ SYSCALL_DEFINE5(mount, char __user *, de
 	char *kernel_dev;
 	unsigned long data_page;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	ret = copy_mount_string(type, &kernel_type);
 	if (ret < 0)
 		goto out_type;
@@ -2200,6 +2210,11 @@ SYSCALL_DEFINE2(pivot_root, const char _
 	struct path new, old, parent_path, root_parent, root;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
diff -ruNp linux-2.6.34.5/fs/nfsctl.c linux-2.6.34.5-cher1/fs/nfsctl.c
--- linux-2.6.34.5/fs/nfsctl.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/nfsctl.c	2010-08-26 14:45:12.301724788 +0400
@@ -91,6 +91,11 @@ SYSCALL_DEFINE3(nfsservctl, int, cmd, st
 	int version;
 	int err;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (copy_from_user(&version, &arg->ca_version, sizeof(int)))
 		return -EFAULT;
 
diff -ruNp linux-2.6.34.5/fs/notify/inotify/inotify_user.c linux-2.6.34.5-cher1/fs/notify/inotify/inotify_user.c
--- linux-2.6.34.5/fs/notify/inotify/inotify_user.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/notify/inotify/inotify_user.c	2010-08-26 14:45:12.302567505 +0400
@@ -643,6 +643,11 @@ SYSCALL_DEFINE1(inotify_init1, int, flag
 	struct user_struct *user;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* Check the IN_* constants for consistency.  */
 	BUILD_BUG_ON(IN_CLOEXEC != O_CLOEXEC);
 	BUILD_BUG_ON(IN_NONBLOCK != O_NONBLOCK);
@@ -692,6 +697,11 @@ SYSCALL_DEFINE3(inotify_add_watch, int, 
 	int ret, fput_needed;
 	unsigned flags = 0;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	filp = fget_light(fd, &fput_needed);
 	if (unlikely(!filp))
 		return -EBADF;
@@ -730,6 +740,11 @@ SYSCALL_DEFINE2(inotify_rm_watch, int, f
 	struct file *filp;
 	int ret = 0, fput_needed;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	filp = fget_light(fd, &fput_needed);
 	if (unlikely(!filp))
 		return -EBADF;
diff -ruNp linux-2.6.34.5/fs/open.c linux-2.6.34.5-cher1/fs/open.c
--- linux-2.6.34.5/fs/open.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/open.c	2010-08-26 14:45:12.303572466 +0400
@@ -130,6 +130,9 @@ SYSCALL_DEFINE2(statfs, const char __use
 	struct path path;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	error = user_path(pathname, &path);
 	if (!error) {
 		struct statfs tmp;
@@ -146,6 +149,9 @@ SYSCALL_DEFINE3(statfs64, const char __u
 	struct path path;
 	long error;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 	error = user_path(pathname, &path);
@@ -165,6 +171,9 @@ SYSCALL_DEFINE2(fstatfs, unsigned int, f
 	struct statfs tmp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -183,6 +192,9 @@ SYSCALL_DEFINE3(fstatfs64, unsigned int,
 	struct statfs64 tmp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 
@@ -292,6 +304,9 @@ out:
 
 SYSCALL_DEFINE2(truncate, const char __user *, path, long, length)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return do_sys_truncate(path, length);
 }
 
@@ -343,7 +358,12 @@ out:
 
 SYSCALL_DEFINE2(ftruncate, unsigned int, fd, unsigned long, length)
 {
-	long ret = do_sys_ftruncate(fd, length, 1);
+        long ret;
+
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
+	ret = do_sys_ftruncate(fd, length, 1);
 	/* avoid REGPARM breakage on x86: */
 	asmlinkage_protect(2, ret, fd, length);
 	return ret;
@@ -353,11 +373,17 @@ SYSCALL_DEFINE2(ftruncate, unsigned int,
 #if BITS_PER_LONG == 32
 SYSCALL_DEFINE(truncate64)(const char __user * path, loff_t length)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return do_sys_truncate(path, length);
 }
 #ifdef CONFIG_HAVE_SYSCALL_WRAPPERS
 asmlinkage long SyS_truncate64(long path, loff_t length)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return SYSC_truncate64((const char __user *) path, length);
 }
 SYSCALL_ALIAS(sys_truncate64, SyS_truncate64);
@@ -365,7 +391,12 @@ SYSCALL_ALIAS(sys_truncate64, SyS_trunca
 
 SYSCALL_DEFINE(ftruncate64)(unsigned int fd, loff_t length)
 {
-	long ret = do_sys_ftruncate(fd, length, 0);
+        long ret;
+
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
+	ret = do_sys_ftruncate(fd, length, 0);
 	/* avoid REGPARM breakage on x86: */
 	asmlinkage_protect(2, ret, fd, length);
 	return ret;
@@ -373,6 +404,9 @@ SYSCALL_DEFINE(ftruncate64)(unsigned int
 #ifdef CONFIG_HAVE_SYSCALL_WRAPPERS
 asmlinkage long SyS_ftruncate64(long fd, loff_t length)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return SYSC_ftruncate64((unsigned int) fd, length);
 }
 SYSCALL_ALIAS(sys_ftruncate64, SyS_ftruncate64);
@@ -427,6 +461,9 @@ SYSCALL_DEFINE(fallocate)(int fd, int mo
 	struct file *file;
 	int error = -EBADF;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	file = fget(fd);
 	if (file) {
 		error = do_fallocate(file, mode, offset, len);
@@ -439,6 +476,9 @@ SYSCALL_DEFINE(fallocate)(int fd, int mo
 #ifdef CONFIG_HAVE_SYSCALL_WRAPPERS
 asmlinkage long SyS_fallocate(long fd, long mode, loff_t offset, loff_t len)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return SYSC_fallocate((int)fd, (int)mode, offset, len);
 }
 SYSCALL_ALIAS(sys_fallocate, SyS_fallocate);
@@ -457,6 +497,9 @@ SYSCALL_DEFINE3(faccessat, int, dfd, con
 	struct inode *inode;
 	int res;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (mode & ~S_IRWXO)	/* where's F_OK, X_OK, W_OK, R_OK? */
 		return -EINVAL;
 
@@ -529,6 +572,11 @@ SYSCALL_DEFINE1(chdir, const char __user
 	struct path path;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+        	return -EPERM;
+	}
+
 	error = user_path_dir(filename, &path);
 	if (error)
 		goto out;
@@ -551,6 +599,11 @@ SYSCALL_DEFINE1(fchdir, unsigned int, fd
 	struct inode *inode;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+        	return -EPERM;
+	}
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -576,6 +629,11 @@ SYSCALL_DEFINE1(chroot, const char __use
 	struct path path;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+        	return -EPERM;
+	}
+
 	error = user_path_dir(filename, &path);
 	if (error)
 		goto out;
@@ -607,6 +665,11 @@ SYSCALL_DEFINE2(fchmod, unsigned int, fd
 	int err = -EBADF;
 	struct iattr newattrs;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+        	return -EPERM;
+	}
+
 	file = fget(fd);
 	if (!file)
 		goto out;
@@ -644,6 +707,11 @@ SYSCALL_DEFINE3(fchmodat, int, dfd, cons
 	int error;
 	struct iattr newattrs;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+        	return -EPERM;
+	}
+
 	error = user_path_at(dfd, filename, LOOKUP_FOLLOW, &path);
 	if (error)
 		goto out;
@@ -707,6 +775,11 @@ SYSCALL_DEFINE3(chown, const char __user
 	struct path path;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+        	return -EPERM;
+	}
+
 	error = user_path(filename, &path);
 	if (error)
 		goto out;
@@ -728,6 +801,11 @@ SYSCALL_DEFINE5(fchownat, int, dfd, cons
 	int error = -EINVAL;
 	int follow;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+        	return -EPERM;
+	}
+
 	if ((flag & ~AT_SYMLINK_NOFOLLOW) != 0)
 		goto out;
 
@@ -751,6 +829,11 @@ SYSCALL_DEFINE3(lchown, const char __use
 	struct path path;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+        	return -EPERM;
+	}
+
 	error = user_lpath(filename, &path);
 	if (error)
 		goto out;
@@ -771,6 +854,11 @@ SYSCALL_DEFINE3(fchown, unsigned int, fd
 	int error = -EBADF;
 	struct dentry * dentry;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+        	return -EPERM;
+	}
+
 	file = fget(fd);
 	if (!file)
 		goto out;
@@ -1041,15 +1129,44 @@ void fd_install(unsigned int fd, struct 
 
 EXPORT_SYMBOL(fd_install);
 
+static int is_secure_path(const char *path)
+{
+	const char *s;
+
+	if (!strncmp(path, "/usr/lib/", 9) || !strncmp(path, "/lib/", 5)) {
+		if (strstr(path, ".."))
+			return -1;
+		return 0;
+	}
+
+	if (!strncmp(path, "/SANDBOX/", 9)) path += 9;
+	s = path;
+	while (s[0] == '.' && s[1] == '/') s += 2;
+	for (; *s && *s != '/'; s++);
+	if (*s == '/') return -1;
+	return 0;
+}
+
 long do_sys_open(int dfd, const char __user *filename, int flags, int mode)
 {
 	char *tmp = getname(filename);
-	int fd = PTR_ERR(tmp);
+        char *tmpname = tmp;
+	int fd;
+
+        if (!IS_ERR(tmp) && (current->sbox_flags & SBOX_NO_SYSCALLS)) {
+        	if (is_secure_path(tmp) < 0) {
+                	putname(tmp);
+                        return -EPERM;
+                }
+                if (!strncmp(tmp, "/SANDBOX/", 9)) tmpname += 9;
+                flags &= ~(O_CREAT | O_EXCL);
+	}
 
+        fd = PTR_ERR(tmp);
 	if (!IS_ERR(tmp)) {
 		fd = get_unused_fd_flags(flags);
 		if (fd >= 0) {
-			struct file *f = do_filp_open(dfd, tmp, flags, mode, 0);
+			struct file *f = do_filp_open(dfd, tmpname, flags, mode, 0);
 			if (IS_ERR(f)) {
 				put_unused_fd(fd);
 				fd = PTR_ERR(f);
@@ -1081,6 +1198,9 @@ SYSCALL_DEFINE4(openat, int, dfd, const 
 {
 	long ret;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (force_o_largefile())
 		flags |= O_LARGEFILE;
 
@@ -1173,6 +1293,11 @@ EXPORT_SYMBOL(sys_close);
  */
 SYSCALL_DEFINE0(vhangup)
 {
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (capable(CAP_SYS_TTY_CONFIG)) {
 		tty_vhangup_self();
 		return 0;
diff -ruNp linux-2.6.34.5/fs/pipe.c linux-2.6.34.5-cher1/fs/pipe.c
--- linux-2.6.34.5/fs/pipe.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/pipe.c	2010-08-26 14:45:12.304562480 +0400
@@ -1077,6 +1077,11 @@ SYSCALL_DEFINE2(pipe2, int __user *, fil
 	int fd[2];
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = do_pipe_flags(fd, flags);
 	if (!error) {
 		if (copy_to_user(fildes, fd, sizeof(fd))) {
diff -ruNp linux-2.6.34.5/fs/proc/base.c linux-2.6.34.5-cher1/fs/proc/base.c
--- linux-2.6.34.5/fs/proc/base.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/proc/base.c	2010-08-26 14:45:12.305572540 +0400
@@ -476,6 +476,10 @@ static const struct limit_names lnames[R
 	[RLIMIT_NICE] = {"Max nice priority", NULL},
 	[RLIMIT_RTPRIO] = {"Max realtime priority", NULL},
 	[RLIMIT_RTTIME] = {"Max realtime timeout", "us"},
+        [RLIMIT_FUTURE1] = {"Future use 1", NULL},
+        [RLIMIT_FUTURE2] = {"Future use 2", NULL},
+        [RLIMIT_FUTURE3] = {"Future use 3", NULL},
+        [RLIMIT_MCPU] = { "Max cpu time", "ms" },
 };
 
 /* Display limits for a process */
diff -ruNp linux-2.6.34.5/fs/quota/compat.c linux-2.6.34.5-cher1/fs/quota/compat.c
--- linux-2.6.34.5/fs/quota/compat.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/quota/compat.c	2010-08-26 14:45:12.316557123 +0400
@@ -52,6 +52,11 @@ asmlinkage long sys32_quotactl(unsigned 
 	u16 xdata;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	cmds = cmd >> SUBCMDSHIFT;
 
 	switch (cmds) {
diff -ruNp linux-2.6.34.5/fs/quota/quota.c linux-2.6.34.5-cher1/fs/quota/quota.c
--- linux-2.6.34.5/fs/quota/quota.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/quota/quota.c	2010-08-26 14:45:12.317578007 +0400
@@ -316,6 +316,11 @@ SYSCALL_DEFINE4(quotactl, unsigned int, 
 	struct super_block *sb = NULL;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	cmds = cmd >> SUBCMDSHIFT;
 	type = cmd & SUBCMDMASK;
 
diff -ruNp linux-2.6.34.5/fs/readdir.c linux-2.6.34.5-cher1/fs/readdir.c
--- linux-2.6.34.5/fs/readdir.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/readdir.c	2010-08-26 14:45:12.317578007 +0400
@@ -109,6 +109,9 @@ SYSCALL_DEFINE3(old_readdir, unsigned in
 	struct file * file;
 	struct readdir_callback buf;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -196,6 +199,9 @@ SYSCALL_DEFINE3(getdents, unsigned int, 
 	struct getdents_callback buf;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
@@ -278,6 +284,9 @@ SYSCALL_DEFINE3(getdents64, unsigned int
 	struct getdents_callback64 buf;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
diff -ruNp linux-2.6.34.5/fs/read_write.c linux-2.6.34.5-cher1/fs/read_write.c
--- linux-2.6.34.5/fs/read_write.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/read_write.c	2010-08-26 14:45:12.318578009 +0400
@@ -153,6 +153,9 @@ SYSCALL_DEFINE3(lseek, unsigned int, fd,
 	struct file * file;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	retval = -EBADF;
 	file = fget_light(fd, &fput_needed);
 	if (!file)
@@ -180,6 +183,9 @@ SYSCALL_DEFINE5(llseek, unsigned int, fd
 	loff_t offset;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	retval = -EBADF;
 	file = fget_light(fd, &fput_needed);
 	if (!file)
@@ -413,6 +419,9 @@ SYSCALL_DEFINE(pread64)(unsigned int fd,
 	ssize_t ret = -EBADF;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (pos < 0)
 		return -EINVAL;
 
@@ -429,6 +438,9 @@ SYSCALL_DEFINE(pread64)(unsigned int fd,
 #ifdef CONFIG_HAVE_SYSCALL_WRAPPERS
 asmlinkage long SyS_pread64(long fd, long buf, long count, loff_t pos)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return SYSC_pread64((unsigned int) fd, (char __user *) buf,
 			    (size_t) count, pos);
 }
@@ -442,6 +454,9 @@ SYSCALL_DEFINE(pwrite64)(unsigned int fd
 	ssize_t ret = -EBADF;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (pos < 0)
 		return -EINVAL;
 
@@ -458,6 +473,9 @@ SYSCALL_DEFINE(pwrite64)(unsigned int fd
 #ifdef CONFIG_HAVE_SYSCALL_WRAPPERS
 asmlinkage long SyS_pwrite64(long fd, long buf, long count, loff_t pos)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return SYSC_pwrite64((unsigned int) fd, (const char __user *) buf,
 			     (size_t) count, pos);
 }
@@ -747,6 +765,9 @@ SYSCALL_DEFINE5(preadv, unsigned long, f
 	ssize_t ret = -EBADF;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (pos < 0)
 		return -EINVAL;
 
@@ -772,6 +793,9 @@ SYSCALL_DEFINE5(pwritev, unsigned long, 
 	ssize_t ret = -EBADF;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (pos < 0)
 		return -EINVAL;
 
@@ -883,6 +907,9 @@ SYSCALL_DEFINE4(sendfile, int, out_fd, i
 	off_t off;
 	ssize_t ret;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (offset) {
 		if (unlikely(get_user(off, offset)))
 			return -EFAULT;
@@ -901,6 +928,9 @@ SYSCALL_DEFINE4(sendfile64, int, out_fd,
 	loff_t pos;
 	ssize_t ret;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (offset) {
 		if (unlikely(copy_from_user(&pos, offset, sizeof(loff_t))))
 			return -EFAULT;
diff -ruNp linux-2.6.34.5/fs/signalfd.c linux-2.6.34.5-cher1/fs/signalfd.c
--- linux-2.6.34.5/fs/signalfd.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/signalfd.c	2010-08-26 14:45:12.326627887 +0400
@@ -214,6 +214,11 @@ SYSCALL_DEFINE4(signalfd4, int, ufd, sig
 	sigset_t sigmask;
 	struct signalfd_ctx *ctx;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* Check the SFD_* constants for consistency.  */
 	BUILD_BUG_ON(SFD_CLOEXEC != O_CLOEXEC);
 	BUILD_BUG_ON(SFD_NONBLOCK != O_NONBLOCK);
diff -ruNp linux-2.6.34.5/fs/splice.c linux-2.6.34.5-cher1/fs/splice.c
--- linux-2.6.34.5/fs/splice.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/splice.c	2010-08-26 14:45:12.328562170 +0400
@@ -1627,6 +1627,11 @@ SYSCALL_DEFINE4(vmsplice, int, fd, const
 	long error;
 	int fput;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (unlikely(nr_segs > UIO_MAXIOV))
 		return -EINVAL;
 	else if (unlikely(!nr_segs))
@@ -1654,6 +1659,11 @@ SYSCALL_DEFINE6(splice, int, fd_in, loff
 	struct file *in, *out;
 	int fput_in, fput_out;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (unlikely(!len))
 		return 0;
 
@@ -1994,6 +2004,11 @@ SYSCALL_DEFINE4(tee, int, fdin, int, fdo
 	struct file *in;
 	int error, fput_in;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (unlikely(!len))
 		return 0;
 
diff -ruNp linux-2.6.34.5/fs/stat.c linux-2.6.34.5-cher1/fs/stat.c
--- linux-2.6.34.5/fs/stat.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/stat.c	2010-08-26 14:45:12.328562170 +0400
@@ -147,11 +147,47 @@ static int cp_old_stat(struct kstat *sta
 	return copy_to_user(statbuf,&tmp,sizeof(tmp)) ? -EFAULT : 0;
 }
 
+static int is_secure_path(const char *path)
+{
+	const char *s;
+
+	if (!strncmp(path, "/usr/lib/", 9) || !strncmp(path, "/lib/", 5)) {
+		if (strstr(path, ".."))
+			return -1;
+		return 0;
+	}
+
+	if (!strncmp(path, "/SANDBOX/", 9)) path += 9;
+	s = path;
+	while (s[0] == '.' && s[1] == '/') s += 2;
+	for (; *s && *s != '/'; s++);
+	if (*s == '/') return -1;
+	return 0;
+}
+
+static int is_secure_stat(char __user *filename)
+{
+	if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+		char *tmp = getname(filename);
+		if (IS_ERR(tmp)) return -EFAULT;
+		if (is_secure_path(tmp) < 0) {
+			putname(tmp);
+			return -EPERM;
+		}
+		putname(tmp);
+	}
+	return 0;
+}
+
 SYSCALL_DEFINE2(stat, char __user *, filename, struct __old_kernel_stat __user *, statbuf)
 {
 	struct kstat stat;
 	int error;
 
+        error = is_secure_stat(filename);
+        if (error)
+		return error;
+
 	error = vfs_stat(filename, &stat);
 	if (error)
 		return error;
@@ -164,6 +200,10 @@ SYSCALL_DEFINE2(lstat, char __user *, fi
 	struct kstat stat;
 	int error;
 
+        error = is_secure_stat(filename);
+        if (error)
+        	return error;
+
 	error = vfs_lstat(filename, &stat);
 	if (error)
 		return error;
@@ -174,8 +214,12 @@ SYSCALL_DEFINE2(lstat, char __user *, fi
 SYSCALL_DEFINE2(fstat, unsigned int, fd, struct __old_kernel_stat __user *, statbuf)
 {
 	struct kstat stat;
-	int error = vfs_fstat(fd, &stat);
+	int error;
+
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
 
+        error = vfs_fstat(fd, &stat);
 	if (!error)
 		error = cp_old_stat(&stat, statbuf);
 
@@ -237,8 +281,13 @@ static int cp_new_stat(struct kstat *sta
 SYSCALL_DEFINE2(newstat, char __user *, filename, struct stat __user *, statbuf)
 {
 	struct kstat stat;
-	int error = vfs_stat(filename, &stat);
+	int error;
+
+        error = is_secure_stat(filename);
+        if (error)
+        	return error;
 
+        error = vfs_stat(filename, &stat);
 	if (error)
 		return error;
 	return cp_new_stat(&stat, statbuf);
@@ -249,6 +298,10 @@ SYSCALL_DEFINE2(newlstat, char __user *,
 	struct kstat stat;
 	int error;
 
+        error = is_secure_stat(filename);
+        if (error)
+        	return error;
+
 	error = vfs_lstat(filename, &stat);
 	if (error)
 		return error;
@@ -263,6 +316,9 @@ SYSCALL_DEFINE4(newfstatat, int, dfd, ch
 	struct kstat stat;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	error = vfs_fstatat(dfd, filename, &stat, flag);
 	if (error)
 		return error;
@@ -275,6 +331,9 @@ SYSCALL_DEFINE2(newfstat, unsigned int, 
 	struct kstat stat;
 	int error = vfs_fstat(fd, &stat);
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (!error)
 		error = cp_new_stat(&stat, statbuf);
 
@@ -287,6 +346,9 @@ SYSCALL_DEFINE4(readlinkat, int, dfd, co
 	struct path path;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	if (bufsiz <= 0)
 		return -EINVAL;
 
@@ -358,8 +420,13 @@ static long cp_new_stat64(struct kstat *
 SYSCALL_DEFINE2(stat64, char __user *, filename, struct stat64 __user *, statbuf)
 {
 	struct kstat stat;
-	int error = vfs_stat(filename, &stat);
+	int error;
 
+        error = is_secure_stat(filename);
+        if (error)
+        	return error;
+
+        error = vfs_stat(filename, &stat);
 	if (!error)
 		error = cp_new_stat64(&stat, statbuf);
 
@@ -369,8 +436,13 @@ SYSCALL_DEFINE2(stat64, char __user *, f
 SYSCALL_DEFINE2(lstat64, char __user *, filename, struct stat64 __user *, statbuf)
 {
 	struct kstat stat;
-	int error = vfs_lstat(filename, &stat);
+	int error;
 
+        error = is_secure_stat(filename);
+        if (error)
+        	return error;
+
+        error = vfs_lstat(filename, &stat);
 	if (!error)
 		error = cp_new_stat64(&stat, statbuf);
 
@@ -380,8 +452,12 @@ SYSCALL_DEFINE2(lstat64, char __user *, 
 SYSCALL_DEFINE2(fstat64, unsigned long, fd, struct stat64 __user *, statbuf)
 {
 	struct kstat stat;
-	int error = vfs_fstat(fd, &stat);
+	int error;
+
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
 
+        error = vfs_fstat(fd, &stat);
 	if (!error)
 		error = cp_new_stat64(&stat, statbuf);
 
@@ -394,6 +470,9 @@ SYSCALL_DEFINE4(fstatat64, int, dfd, cha
 	struct kstat stat;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	error = vfs_fstatat(dfd, filename, &stat, flag);
 	if (error)
 		return error;
diff -ruNp linux-2.6.34.5/fs/super.c linux-2.6.34.5-cher1/fs/super.c
--- linux-2.6.34.5/fs/super.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/super.c	2010-08-26 14:45:12.329557004 +0400
@@ -540,6 +540,9 @@ SYSCALL_DEFINE2(ustat, unsigned, dev, st
         struct kstatfs sbuf;
 	int err = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
         s = user_get_super(new_decode_dev(dev));
         if (s == NULL)
                 goto out;
diff -ruNp linux-2.6.34.5/fs/sync.c linux-2.6.34.5-cher1/fs/sync.c
--- linux-2.6.34.5/fs/sync.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/sync.c	2010-08-26 14:45:12.329557004 +0400
@@ -129,6 +129,9 @@ restart:
  */
 SYSCALL_DEFINE0(sync)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	wakeup_flusher_threads(0);
 	sync_filesystems(0);
 	sync_filesystems(1);
@@ -279,11 +282,17 @@ static int do_fsync(unsigned int fd, int
 
 SYSCALL_DEFINE1(fsync, unsigned int, fd)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return do_fsync(fd, 0);
 }
 
 SYSCALL_DEFINE1(fdatasync, unsigned int, fd)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	return do_fsync(fd, 1);
 }
 
@@ -362,6 +371,9 @@ SYSCALL_DEFINE(sync_file_range)(int fd, 
 	int fput_needed;
 	umode_t i_mode;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	ret = -EINVAL;
 	if (flags & ~VALID_FLAGS)
 		goto out;
@@ -439,6 +451,9 @@ out:
 asmlinkage long SyS_sync_file_range(long fd, loff_t offset, loff_t nbytes,
 				    long flags)
 {
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	return SYSC_sync_file_range((int) fd, offset, nbytes,
 				    (unsigned int) flags);
 }
diff -ruNp linux-2.6.34.5/fs/timerfd.c linux-2.6.34.5-cher1/fs/timerfd.c
--- linux-2.6.34.5/fs/timerfd.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/timerfd.c	2010-08-26 14:45:12.330575305 +0400
@@ -183,6 +183,11 @@ SYSCALL_DEFINE2(timerfd_create, int, clo
 	int ufd;
 	struct timerfd_ctx *ctx;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* Check the TFD_* constants for consistency.  */
 	BUILD_BUG_ON(TFD_CLOEXEC != O_CLOEXEC);
 	BUILD_BUG_ON(TFD_NONBLOCK != O_NONBLOCK);
@@ -216,6 +221,11 @@ SYSCALL_DEFINE4(timerfd_settime, int, uf
 	struct timerfd_ctx *ctx;
 	struct itimerspec ktmr, kotmr;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (copy_from_user(&ktmr, utmr, sizeof(ktmr)))
 		return -EFAULT;
 
@@ -272,6 +282,11 @@ SYSCALL_DEFINE2(timerfd_gettime, int, uf
 	struct timerfd_ctx *ctx;
 	struct itimerspec kotmr;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	file = timerfd_fget(ufd);
 	if (IS_ERR(file))
 		return PTR_ERR(file);
diff -ruNp linux-2.6.34.5/fs/utimes.c linux-2.6.34.5-cher1/fs/utimes.c
--- linux-2.6.34.5/fs/utimes.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/fs/utimes.c	2010-08-26 14:45:12.330575305 +0400
@@ -28,6 +28,11 @@ SYSCALL_DEFINE2(utime, char __user *, fi
 {
 	struct timespec tv[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (times) {
 		if (get_user(tv[0].tv_sec, &times->actime) ||
 		    get_user(tv[1].tv_sec, &times->modtime))
@@ -175,6 +180,11 @@ SYSCALL_DEFINE4(utimensat, int, dfd, cha
 {
 	struct timespec tstimes[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (utimes) {
 		if (copy_from_user(&tstimes, utimes, sizeof(tstimes)))
 			return -EFAULT;
@@ -194,6 +204,11 @@ SYSCALL_DEFINE3(futimesat, int, dfd, cha
 	struct timeval times[2];
 	struct timespec tstimes[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (utimes) {
 		if (copy_from_user(&times, utimes, sizeof(times)))
 			return -EFAULT;
